package uam.patrones.template.operaciones;

import uam.patrones.template.clases.Alumno;

public abstract class TemplatePattern {

	public void inscribirAlumno(String nombre, String matricula, String actividad) {
		Alumno alumno = new Alumno(nombre, matricula);
		validarAlumno( alumno);
		registrarBitacora(alumno, actividad);
		validarActividad(actividad);
		registrarAlumno(alumno, actividad);
	}
	
	public boolean validarAlumno(Alumno alumno) {
		
		System.out.println("Se está validando al alumno " + alumno.getMatricula());
		return true;
	}
	
	public void registrarBitacora(Alumno alumno, String actividad) {
		System.out.println("Rectoría está registrando la actividad "
				+ "extra curricular " + actividad + " para el alumno "
				+ alumno.getMatricula());
	}
	
	public abstract void validarActividad(String actividad);
	public abstract void registrarAlumno(Alumno alumno, String actividad);
	
	
}
